/**************************************************************************************

        PROTUX - THE FREE PROFESSIONAL AUDIO TOOLS FOR LINUX
        AUTHOR : See AUTHORS file for details

        This software is distributed under the terms of the GNU General Public License
        as specified in the COPYING file.

***************************************************************************************/
#ifndef AUDIOCLIP_HH
#define AUDIOCLIP_HH

#include <mustux.h>

class Audio;
class Song;
class Track;

class AudioClip : public MustuxDrawableRegion
        {
        public:
                
                AudioClip(Track* pParentTrack, Audio *anAudioSource, long long aSourceFirstBlock, long long aLenght, long long aTrackInsertPos);
                ~AudioClip();

                void update();
                int draw();
                int draw_clip_rect();
                int play();
                int split();
                void clear();
                void set_muted(bool b);
                void set_selected(bool b);
                long long get_lenght();

                Audio* get_audio_source();
                AudioClip* prev;
                AudioClip* next;
                Track* parentTrack;
                Song* parentSong;
                Audio* audioSource;
                void set_blur(bool stat);

                QString clipName;
                long long sourceFirstBlock;
                long long sourceLastBlock;
                long long trackFirstBlock;
                long long trackLastBlock;
                bool isMuted;
                bool isSelected;
                bool isTake;
                int blockSize;
                int channels;
                int rate;
                int bitDepth;
                int bytesPerSample;
                long maxSample;

                void set_track_first_block(long long newTrackFirstBlock);
                void set_left_edge(long long block);
                void set_right_edge(long long block);
                void set_last_source_block(long long block);
                void set_first_source_block(long long block);
                void extend_to_end(); // DEPRECATED

                int get_baseX();
                int get_baseY();
                int get_width();
                int get_height();

        };

#include "Audio.hh"
#include "Track.hh"
#include "Song.hh"

#endif
