/**************************************************************************************

        PROTUX - THE FREE PROFESSIONAL AUDIO TOOLS FOR LINUX
        AUTHOR : See AUTHORS file for details

        This software is distributed under the terms of the GNU General Public License
        as specified in the COPYING file.

***************************************************************************************/
#include "ProjectManager.hh"

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <qvariant.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qprogressbar.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qtabwidget.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
// #include <qmemarray.h>

#include <mustux.h>

#include "FileBrowser.hh"
#include "DevelGuardian.hh"
#include "Interface.hh"

static const char* const image0_data[] = {
        "18 19 10 1",
        "d c #00d200",
        "f c #18d618",
        "c c #39de39",
        "g c #52e252",
        "e c #73e673",
        "h c #8bea8b",
        "a c #acf2ac",
        "b c #c5f6c5",
        "# c #e6fae6",
        ". c #ffffff",
        "...............#a#",
        ".............bcddb",
        "............bddde.",
        "...........#fddg..",
        "...........cddf#..",
        "..........eddd#...",
        ".........bddda....",
        ".........fdde.....",
        "........gddc......",
        ".......addf#......",
        "..#b..#fdda.......",
        ".gdd#.gddg........",
        "adddhaddf.........",
        "#dddffddb.........",
        ".cddddde..........",
        ".hddddf...........",
        ".#ddddb...........",
        "..eddg............",
        "...##............."};

ProjectManager::ProjectManager( Interface* pParentInterface,  const char* name )
    : QDialog( (QWidget*) 0, name )
{
  parentInterface = pParentInterface;
        PENTERCONS;
        QHBoxLayout* lay010101;
        QHBoxLayout* lay010102;
        QHBoxLayout* lay010103;
        QHBoxLayout* Layout25;
        QHBoxLayout* lay010104;
        QHBoxLayout* lay0204;
        QHBoxLayout* lay0203;
        QHBoxLayout* Layout41;
        QHBoxLayout* lay0201;
        QHBoxLayout* lay02012;
        QHBoxLayout* lay030101;
        QHBoxLayout* Layout32;
        QHBoxLayout* Layout26;
        QHBoxLayout* Layout32_2;
        QHBoxLayout* Layout26_2;
        QHBoxLayout* Layout34_2;
        QHBoxLayout* Layout19_2_2;
        QHBoxLayout* Layout34;
        QHBoxLayout* Layout19_2;
        QHBoxLayout* Layout32_2_2;


        QPixmap image0( ( const char** ) image0_data );
        if ( !name )
                setName( "ProjectManager" );
        resize( 730, 488 );
        setMaximumSize( QSize( 1200, 1200 ) );
        setCaption( "<FS> File Stuff / Project Manager" );

        mainTabPane = new QTabWidget( this, "mainTabPane" );
        mainTabPane->setGeometry( QRect( 0, 0, 730, 490 ) );

	// Album Project tab
        tab = new QWidget( mainTabPane, "tab" );

        QWidget* privateLayoutWidget = new QWidget( tab, "lay010101" );
        privateLayoutWidget->setGeometry( QRect( 10, 300, 710, 24 ) );
        lay010101 = new QHBoxLayout( privateLayoutWidget, 0, 6, "lay010101");

        lblAlbumTitle = new QLabel( privateLayoutWidget, "lblAlbumTitle" );
        lblAlbumTitle->setMinimumSize( QSize( 65, 0 ) );
        lblAlbumTitle->setText( tr( "CURRENT PROJECT : Title" ) );
        lay010101->addWidget( lblAlbumTitle );

        fieldAlbumTitle = new QLineEdit( privateLayoutWidget, "fieldAlbumTitle" );
        fieldAlbumTitle->setText( tr( "" ) );
        lay010101->addWidget( fieldAlbumTitle );

        QWidget* privateLayoutWidget_2 = new QWidget( tab, "lay010102" );
        privateLayoutWidget_2->setGeometry( QRect( 10, 330, 710, 22 ) );
        lay010102 = new QHBoxLayout( privateLayoutWidget_2, 0, 6, "lay010102");

        lblNOfSongs = new QLabel( privateLayoutWidget_2, "lblNOfSongs" );
        lblNOfSongs->setText( tr( "N.of Songs" ) );
        lay010102->addWidget( lblNOfSongs );

        fieldNOfSongs = new QLineEdit( privateLayoutWidget_2, "fieldNOfSongs" );
        fieldNOfSongs->setMaximumSize(QSize(60,20));
        fieldNOfSongs->setEnabled( FALSE );
        fieldNOfSongs->setText( tr( "1" ) );
        lay010102->addWidget( fieldNOfSongs );

        lblStatus = new QLabel( privateLayoutWidget_2, "lblStatus" );
        lblStatus->setText( tr( "Status" ) );
        lay010102->addWidget( lblStatus );

        cmbStatus = new QComboBox( FALSE, privateLayoutWidget_2, "cmbStatus" );
        cmbStatus->insertItem( tr( "Planning" ) );
        cmbStatus->insertItem( tr( "Rehearsals" ) );
        cmbStatus->insertItem( tr( "Recording" ) );
        cmbStatus->insertItem( tr( "Finishing" ) );
        cmbStatus->insertItem( tr( "Tournee" ) );
        lay010102->addWidget( cmbStatus );

        lblTotalDur = new QLabel( privateLayoutWidget_2, "lblTotalDur" );
        lblTotalDur->setText( tr( "Dur: ???" ) );
        lay010102->addWidget( lblTotalDur );

        QWidget* privateLayoutWidget_3 = new QWidget( tab, "lay010103" );
        privateLayoutWidget_3->setGeometry( QRect( 10, 360, 710, 24 ) );
        lay010103 = new QHBoxLayout( privateLayoutWidget_3, 0, 6, "lay010103");

        lblEngineer = new QLabel( privateLayoutWidget_3, "lblEngineer" );
        lblEngineer->setMinimumSize( QSize( 95, 0 ) );
        lblEngineer->setText( tr( "Protux Engineer" ) );
        lay010103->addWidget( lblEngineer );

        fieldEngineer = new QLineEdit( privateLayoutWidget_3, "fieldEngineer" );
        lay010103->addWidget( fieldEngineer );

        QWidget* privateLayoutWidget_4 = new QWidget( tab, "Layout25" );
        privateLayoutWidget_4->setGeometry( QRect( 10, 420, 710, 24 ) );
        Layout25 = new QHBoxLayout( privateLayoutWidget_4, 0, 6, "Layout25");

        btnRender = new QPushButton( privateLayoutWidget_4, "btnRender" );
        btnRender->setText( tr( "Render ..." ) );
        connect( btnRender, SIGNAL(clicked()), this, SLOT(btnRender_clicked()));
        //QToolTip::add( btnRender, tr( "Render all underendered elements. Do this before burning a CD" ) );
        Layout25->addWidget( btnRender );

        btnMaster = new QPushButton( privateLayoutWidget_4, "btnMaster" );
        btnMaster->setEnabled( FALSE );
        btnMaster->setText( tr( "Master ..." ) );
        connect( btnMaster, SIGNAL(clicked()), this, SLOT(btnMaster_clicked()));
        //QToolTip::add( btnMaster, tr( "Opens the masterization dialog" ) );
        Layout25->addWidget( btnMaster );

        btnBurnCD = new QPushButton( privateLayoutWidget_4, "btnBurnCD" );
        btnBurnCD->setEnabled( FALSE );
        connect( btnBurnCD, SIGNAL(clicked()), this, SLOT(btnBurnCD_clicked()));
        //QFont btnBurnCD_font(  btnBurnCD->font() );
        //btnBurnCD_font.setFamily( "Helvetica" );
        //btnBurnCD_font.setPointSize( 10 );
        //btnBurnCD_font.setBold( TRUE );
        //btnBurnCD->setFont( btnBurnCD_font );
        btnBurnCD->setText( tr( "Burn CD" ) );
        Layout25->addWidget( btnBurnCD );

        QWidget* privateLayoutWidget_5 = new QWidget( tab, "lay010104" );
        privateLayoutWidget_5->setGeometry( QRect( 10, 390, 710, 24 ) );
        lay010104 = new QHBoxLayout( privateLayoutWidget_5, 0, 6, "lay010104");

        btnCreateProject = new QPushButton( privateLayoutWidget_5, "btnCreateProject" );
        btnCreateProject->setText( tr( "CREATE NEW" ) );
        lay010104->addWidget( btnCreateProject );
        connect( btnCreateProject, SIGNAL(clicked()), this, SLOT(btnCreateProject_clicked()));

        btnLoadProject = new QPushButton( privateLayoutWidget_5, "btnLoadProject" );
        btnLoadProject->setText( tr( "LOAD" ) );
        connect( btnLoadProject, SIGNAL(clicked()), this, SLOT(btnLoadProject_clicked()));
        //QToolTip::add( btnSaveProject, tr( "Load this album project (Save your current project first !!!)" ) );

        lay010104->addWidget( btnLoadProject );

        btnSaveProject = new QPushButton( privateLayoutWidget_5, "btnSaveProject" );
        btnSaveProject->setText( tr( "SAVE" ) );
        connect( btnSaveProject, SIGNAL(clicked()), this, SLOT(btnSaveProject_clicked()));
        //QToolTip::add( btnSaveProject, tr( "Save all Song projects under this album project" ) );
        lay010104->addWidget( btnSaveProject );

        btnCopyToProject = new QPushButton( privateLayoutWidget_5, "btnCopyToProject" );
        btnCopyToProject->setText( tr( "Save as" ) );
        connect( btnCopyToProject, SIGNAL(clicked()), this, SLOT(btnCopyToProject_clicked()));
        //QToolTip::add( btnCopyToProject, tr( "Copy this project to another project" ) );
        lay010104->addWidget( btnCopyToProject );

        fieldSaveProjAs = new QLineEdit( privateLayoutWidget_5, "fieldSaveProjAs" );
        lay010104->addWidget( fieldSaveProjAs );

        btnDeleteProject = new QPushButton( privateLayoutWidget_5, "btnDeleteProject" );
        connect( btnDeleteProject, SIGNAL(clicked()), this, SLOT(btnDeleteProject_clicked()));
        btnDeleteProject->setText( tr( "DELETE" ) );
        //QToolTip::add( btnDeleteProject, tr( "Delete current project (DANGER)" ) );
        lay010104->addWidget( btnDeleteProject );

        listAlbumProjects = new QListView( tab, "listAlbumProjects" );
        listAlbumProjects->addColumn( tr( "Album Name" ) );
        listAlbumProjects->addColumn( tr( "N. of songs" ) );
        listAlbumProjects->addColumn( tr( "Space Alloc" ) );
        listAlbumProjects->addColumn( tr( "Status" ) );

        update_projects_list();

        listAlbumProjects->setGeometry( QRect( 10, 10, 710, 280 ) );
	connect(listAlbumProjects, SIGNAL(selectionChanged()), this, SLOT(listAlbumProject_projectSelected()));
        mainTabPane->insertTab( tab, tr( "Album Projects" ) );


	// Songs tab
        tab_2 = new QWidget( mainTabPane, "tab_2" );

        QWidget* privateLayoutWidget_6 = new QWidget( tab_2, "lay0204" );
        privateLayoutWidget_6->setGeometry( QRect( 10, 430, 710, 22 ) );
        lay0204 = new QHBoxLayout( privateLayoutWidget_6, 0, 6, "lay0204");

        lblMasterGain = new QLabel( privateLayoutWidget_6, "lblMasterGain" );
        lblMasterGain->setMinimumSize( QSize( 69, 0 ) );
        lblMasterGain->setText( tr( "Master Gain" ) );
        lay0204->addWidget( lblMasterGain );

        fieldMasterGain = new QLineEdit( privateLayoutWidget_6, "fieldMasterGain" );
        fieldMasterGain->setText( tr( "0.0" ) );
        lay0204->addWidget( fieldMasterGain );

        lblNumTracks = new QLabel( privateLayoutWidget_6, "lblNumTracks" );
        lblNumTracks->setMinimumSize( QSize( 70, 0 ) );
        lblNumTracks->setText( tr( "Num. Tracks" ) );
        lay0204->addWidget( lblNumTracks );

        fieldNumTracks = new QLineEdit( privateLayoutWidget_6, "fieldNumTracks" );
        fieldNumTracks->setText( tr( "14" ) );
        fieldNumTracks->setEnabled(false);
        //QToolTip::add( fieldNumTracks, tr( "To add/remove tracks, use standard JMB actions , such <INSERT> or <DELETE>, right inside MTA" ) );
        lay0204->addWidget( fieldNumTracks );

        lblSongDur = new QLabel( privateLayoutWidget_6, "lblSongDur" );
        lblSongDur->setMinimumSize( QSize( 56, 0 ) );
        lblSongDur->setText( tr( "Duration" ) );
        lblSongDur->setScaledContents( FALSE );
        lay0204->addWidget( lblSongDur );

        fieldSongDur = new QLineEdit( privateLayoutWidget_6, "fieldSongDur" );
        fieldSongDur->setText( tr( "??" ) );
        fieldNumTracks->setEnabled(false);
        lay0204->addWidget( fieldSongDur );

        QWidget* privateLayoutWidget_7 = new QWidget( tab_2, "lay0203" );
        privateLayoutWidget_7->setGeometry( QRect( 10, 400, 710, 24 ) );
        lay0203 = new QHBoxLayout( privateLayoutWidget_7, 0, 6, "lay0203");

        lblArtist = new QLabel( privateLayoutWidget_7, "lblArtist" );
        lblArtist->setMinimumSize( QSize( 60, 0 ) );
        lblArtist->setText( tr( "Artists" ) );
        lay0203->addWidget( lblArtist );

        fieldArtists = new QLineEdit( privateLayoutWidget_7, "fieldArtists" );
        //fieldArtists->setText( tr( "Matt Bradley" ) );
        lay0203->addWidget( fieldArtists );

        QWidget* privateLayoutWidget_8 = new QWidget( tab_2, "Layout41" );
        privateLayoutWidget_8->setGeometry( QRect( 10, 370, 710, 22 ) );
        Layout41 = new QHBoxLayout( privateLayoutWidget_8, 0, 6, "Layout41");

        TextLabel2 = new QLabel( privateLayoutWidget_8, "TextLabel2" );
        //TextLabel2->setText( tr( "Song : Au revoir" ) );
        Layout41->addWidget( TextLabel2 );

        QWidget* privateLayoutWidget_9 = new QWidget( tab_2, "lay0201" );
        privateLayoutWidget_9->setGeometry( QRect( 10, 320, 710, 24 ) );
        lay0201 = new QHBoxLayout( privateLayoutWidget_9, 0, 6, "lay0201");

        btnSaveSong = new QPushButton( privateLayoutWidget_9, "btnSaveSong" );
        connect(btnSaveSong, SIGNAL(clicked()), this, SLOT(btnSaveSong_clicked()));
        btnSaveSong->setMinimumSize( QSize( 80, 0 ) );
        btnSaveSong->setText( tr( "SAVE" ) );
        //QToolTip::add( btnSaveSong, tr( "Save this song project" ) );
        lay0201->addWidget( btnSaveSong );

        btnSaveSongAs = new QPushButton( privateLayoutWidget_9, "btnSaveSongAs" );
        connect( btnSaveSongAs, SIGNAL(clicked()), this, SLOT(btnSaveSongAs_clicked()));
        btnSaveSongAs->setMinimumSize( QSize( 80, 0 ) );
        btnSaveSongAs->setText( tr( "Rename" ) );
        //QToolTip::add( btnSaveSongAs, tr( "Add a new song which is a copy of current song" ) );
        lay0201->addWidget( btnSaveSongAs );

        lblOr = new QLabel( privateLayoutWidget_9, "lblOr" );
        lblOr->setText( tr( "or" ) );
        lay0201->addWidget( lblOr );

        btn = new QPushButton( privateLayoutWidget_9, "btn" );
        btn->setMinimumSize( QSize( 80, 0 ) );
        btn->setText( tr( "COPY as" ) );
        connect( btn, SIGNAL(clicked()), this, SLOT(btnSaveSongCopyAs_clicked()));
        //QToolTip::add( btn, tr( "add an empty song project" ) );
        lay0201->addWidget( btn );

        fieldCopyTo = new QLineEdit( privateLayoutWidget_9, "fieldCopyTo" );
        fieldCopyTo->setMinimumSize( QSize( 410, 0 ) );
        fieldCopyTo->setMaximumSize( QSize( 300, 32767 ) );
        fieldCopyTo->setText( tr( "Revoir (reprise)", "Record" ) );
        lay0201->addWidget( fieldCopyTo );

        listSongs = new QListView( tab_2, "listSongs" );
        listSongs->addColumn( tr( "Song Name" ) );
        listSongs->addColumn( tr( "N. of Tracks" ) );
        listSongs->addColumn( tr( "Space Alloc" ) );
        listSongs->addColumn( tr( "Status" ) );
        QListViewItem * item = new QListViewItem( listSongs, 0 );
        item->setText( 0, tr( "Untitled Song" ) );

        listSongs->setGeometry( QRect( 10, 10, 710, 310 ) );

        QWidget* privateLayoutWidget_91 = new QWidget( tab_2, "lay0201" );
        privateLayoutWidget_91->setGeometry( QRect( 10, 350, 710, 30 ) );
        lay02012 = new QHBoxLayout( privateLayoutWidget_91, 0, 6, "lay0201");
        QPushButton* btnNewSong = new QPushButton( privateLayoutWidget_91, "btnAddSong" );
        btnNewSong->setMinimumSize( QSize( 80, 25 ) );
        btnNewSong->setMaximumSize( QSize( 120, 25 ) );

        btnNewSong->setText( tr( "NEW" ) );
        //QToolTip::add( btnNewSong, tr( "Create a New Song" ) );
        lay02012->addWidget( btnNewSong );

        cmbSongStatus = new QComboBox( FALSE, privateLayoutWidget_91, "cmbSongStatus" );
        cmbSongStatus->insertItem( tr( "Planning" ) );
        cmbSongStatus->insertItem( tr( "Rehearsals" ) );
        cmbSongStatus->insertItem( tr( "Recording" ) );
        cmbSongStatus->insertItem( tr( "Finishing" ) );
        cmbSongStatus->insertItem( tr( "Tournee" ) );
        cmbSongStatus->setMaximumSize( QSize( 94, 32767 ) );
        lay02012->addWidget( cmbSongStatus );

        mainTabPane->insertTab( tab_2, tr( "Songs" ) );


	// Audio Sources tab
        tab_3 = new QWidget( mainTabPane, "tab_3" );

        QWidget* privateLayoutWidget_10 = new QWidget( tab_3, "lay030101" );
        privateLayoutWidget_10->setGeometry( QRect( 10, 310, 700, 24 ) );
        lay030101 = new QHBoxLayout( privateLayoutWidget_10, 0, 6, "lay030101");

        btnDeleteSource = new QPushButton( privateLayoutWidget_10, "btnDeleteSource" );
        connect( btnDeleteSource, SIGNAL(clicked()), this, SLOT(btnDeleteSource_clicked()));
        btnDeleteSource->setText( tr( "Delete" ) );
        lay030101->addWidget( btnDeleteSource );

        btnRemoveAllClips = new QPushButton( privateLayoutWidget_10, "btnRemoveAllClips" );
        btnRemoveAllClips->setText( tr( "Remove All Clips" ) );
        connect( btnRemoveAllClips, SIGNAL(clicked()), this, SLOT(btnRemoveAllClips_clicked()));
        lay030101->addWidget( btnRemoveAllClips );

        btnExportSource = new QPushButton( privateLayoutWidget_10, "btnExportSource" );
        btnExportSource->setText( tr( "Export ..." ) );
        connect( btnExportSource, SIGNAL(clicked()), this, SLOT(btnExportSource_clicked()));
        //QToolTip::add( btnExportSource, tr( "Export selected files to Dir or CD ..." ) );
        lay030101->addWidget( btnExportSource );

        grpPreListenSource = new QGroupBox( tab_3, "grpPreListenSource" );
        grpPreListenSource->setGeometry( QRect( 10, 340, 700, 110 ) );
        grpPreListenSource->setTitle( tr( "Pre-listen" ) );

        btnSourcePlay = new QPushButton( grpPreListenSource, "btnSourcePlay" );
        connect( btnSourcePlay, SIGNAL(clicked()), this, SLOT(btnSourcePlay_clicked()));
        btnSourcePlay->setGeometry( QRect( 10, 20, 260, 22 ) );
        btnSourcePlay->setText( tr( "Play" ) );

        fieldAudioSourceInfo = new QLineEdit( grpPreListenSource, "fieldAudioSourceInfo" );
        fieldAudioSourceInfo->setGeometry( QRect( 280, 20, 260, 70 ) );

        lblSourceSpectro = new QLabel( grpPreListenSource, "lblSourceSpectro" );
        lblSourceSpectro->setGeometry( QRect( 580, 40, 80, 15 ) );
        lblSourceSpectro->setMaximumSize( QSize( 32767, 15 ) );
        lblSourceSpectro->setText( tr( "FFT & Peak" ) );

        QWidget* privateLayoutWidget_11 = new QWidget( grpPreListenSource, "Layout32" );
        privateLayoutWidget_11->setGeometry( QRect( 10, 50, 260, 16 ) );
        Layout32 = new QHBoxLayout( privateLayoutWidget_11, 0, 6, "Layout32");

        lblDSPVol1 = new QLabel( privateLayoutWidget_11, "lblDSPVol1" );
        lblDSPVol1->setText( tr( "Vol" ) );
        Layout32->addWidget( lblDSPVol1 );

        sliderSource = new QSlider( privateLayoutWidget_11, "sliderSource" );
        sliderSource->setMaximumSize( QSize( 32767, 14 ) );
        sliderSource->setOrientation( QSlider::Horizontal );
        Layout32->addWidget( sliderSource );

        QWidget* privateLayoutWidget_12 = new QWidget( grpPreListenSource, "Layout26" );
        privateLayoutWidget_12->setGeometry( QRect( 10, 80, 260, 18 ) );
        Layout26 = new QHBoxLayout( privateLayoutWidget_12, 0, 6, "Layout26");

        checkSourceInfo = new QCheckBox( privateLayoutWidget_12, "checkSourceInfo" );
        checkSourceInfo->setEnabled( TRUE );
        checkSourceInfo->setText( tr( "Auto Info" ) );
        Layout26->addWidget( checkSourceInfo );

        checkSourceSpectro = new QCheckBox( privateLayoutWidget_12, "checkSourceSpectro" );
        checkSourceSpectro->setText( tr( "AutoSpectro" ) );
        Layout26->addWidget( checkSourceSpectro );

        listAudioSources = new QListView( tab_3, "listAudioSources" );
        listAudioSources->addColumn( tr( "Used" ) );
        listAudioSources->addColumn( tr( "Name" ) );
        listAudioSources->addColumn( tr( "Chann" ) );
        listAudioSources->addColumn( tr( "Rate" ) );
        listAudioSources->addColumn( tr( "Bit Depth" ) );
        listAudioSources->addColumn( tr( "Comment" ) );

        /*
        item = new QListViewItem( listAudioSources, 0 );
        item->setPixmap( 0, image0 );
        item->setText( 1, tr( "xxxx.ogg" ) );

        item = new QListViewItem( listAudioSources, item );
        item->setText( 1, tr( "xxxx.wav" ) );

        item = new QListViewItem( listAudioSources, item );
        item->setPixmap( 0, image0 );
        item->setText( 1, tr( "xxxxx.praf" ) );
        */

        listAudioSources->setGeometry( QRect( 10, 10, 700, 290 ) );
        mainTabPane->insertTab( tab_3, tr( "Audio Sources" ) );

        tab_4 = new QWidget( mainTabPane, "tab_4" );

        fileBrowser = new FileBrowser(tab_4);
        fileBrowser->setMinimumSize(QSize(710,260));

        grpPreListenFile = new QGroupBox( tab_4, "grpPreListenFile" );
        grpPreListenFile->setGeometry( QRect( 10, 340, 700, 110 ) );
        grpPreListenFile->setTitle( tr( "Pre-listen" ) );

        QWidget* privateLayoutWidget_13 = new QWidget( grpPreListenFile, "Layout32_2" );
        privateLayoutWidget_13->setGeometry( QRect( 10, 50, 260, 16 ) );
        Layout32_2 = new QHBoxLayout( privateLayoutWidget_13, 0, 6, "Layout32_2");

        lblDSPVol2 = new QLabel( privateLayoutWidget_13, "lblDSPVol2" );
        lblDSPVol2->setText( tr( "Vol" ) );
        Layout32_2->addWidget( lblDSPVol2 );

        sliderFile = new QSlider( privateLayoutWidget_13, "sliderFile" );
        sliderFile->setMaximumSize( QSize( 32767, 14 ) );
        sliderFile->setOrientation( QSlider::Horizontal );
        Layout32_2->addWidget( sliderFile );

        QWidget* privateLayoutWidget_14 = new QWidget( grpPreListenFile, "Layout26_2" );
        privateLayoutWidget_14->setGeometry( QRect( 10, 80, 260, 18 ) );
        Layout26_2 = new QHBoxLayout( privateLayoutWidget_14, 0, 6, "Layout26_2");

        checkFileInfo = new QCheckBox( privateLayoutWidget_14, "checkFileInfo" );
        checkFileInfo->setEnabled( TRUE );
        checkFileInfo->setText( tr( "Auto Info" ) );
        Layout26_2->addWidget( checkFileInfo );

        checkFileSpectro = new QCheckBox( privateLayoutWidget_14, "checkFileSpectro" );
        checkFileSpectro->setText( tr( "AutoSpectro" ) );
        Layout26_2->addWidget( checkFileSpectro );

        lblFileSpectro = new QLabel( grpPreListenFile, "lblFileSpectro" );
        lblFileSpectro->setGeometry( QRect( 570, 60, 80, 15 ) );
        lblFileSpectro->setMaximumSize( QSize( 32767, 15 ) );
        lblFileSpectro->setText( tr( "FFT & Peak" ) );

        fieldFileInfo = new QLineEdit( grpPreListenFile, "fieldFileInfo" );
        fieldFileInfo->setGeometry( QRect( 280, 20, 260, 70 ) );

        btnFilePlay = new QPushButton( grpPreListenFile, "btnFilePlay" );
        connect( btnFilePlay, SIGNAL(clicked()), this, SLOT(btnFilePlay_clicked()));
        btnFilePlay->setGeometry( QRect( 10, 20, 260, 22 ) );
        btnFilePlay->setText( tr( "Play" ) );

        grpImportFile = new QGroupBox( tab_4, "grpImportFile" );
        grpImportFile->setGeometry( QRect( 10, 260, 700, 80 ) );
        grpImportFile->setTitle( tr( "Import" ) );

        QWidget* privateLayoutWidget_15 = new QWidget( grpImportFile, "Layout34_2" );
        privateLayoutWidget_15->setGeometry( QRect( 20, 20, 670, 24 ) );
        Layout34_2 = new QHBoxLayout( privateLayoutWidget_15, 0, 6, "Layout34_2");

        lblFileDestSong = new QLabel( privateLayoutWidget_15, "lblFileDestSong" );
        lblFileDestSong->setMaximumSize( QSize( 57, 32767 ) );
        lblFileDestSong->setText( tr( "Dest: Song" ) );
        Layout34_2->addWidget( lblFileDestSong );

        fieldFileDestSong = new QLineEdit( privateLayoutWidget_15, "fieldFileDestSong" );
        fieldFileDestSong->setMaximumSize( QSize( 25, 32767 ) );
        fieldFileDestSong->setText( tr( "1" ) );
        Layout34_2->addWidget( fieldFileDestSong );

        lblFileDestTrack = new QLabel( privateLayoutWidget_15, "lblFileDestTrack" );
        lblFileDestTrack->setMaximumSize( QSize( 36, 32767 ) );
        lblFileDestTrack->setText( tr( "Track" ) );
        Layout34_2->addWidget( lblFileDestTrack );

        fieldFileDestTrack = new QLineEdit( privateLayoutWidget_15, "fieldFileDestTrack" );
        fieldFileDestTrack->setMaximumSize( QSize( 25, 32767 ) );
        fieldFileDestTrack->setText( tr( "1" ) );
        Layout34_2->addWidget( fieldFileDestTrack );

        lblFileDestPos = new QLabel( privateLayoutWidget_15, "lblFileDestPos" );
        lblFileDestPos->setMaximumSize( QSize( 25, 32767 ) );
        lblFileDestPos->setText( tr( "Pos" ) );
        Layout34_2->addWidget( lblFileDestPos );

        fieldFileDestPos = new QLineEdit( privateLayoutWidget_15, "fieldFileDestPos" );
        fieldFileDestPos->setMinimumSize( QSize( 77, 0 ) );
        fieldFileDestPos->setMaximumSize( QSize( 55, 32767 ) );
        fieldFileDestPos->setText( tr( "0:02:30,14" ) );
        Layout34_2->addWidget( fieldFileDestPos );

        btnAddFileAsSource = new QPushButton( privateLayoutWidget_15, "btnAddFileAsSource" );
        btnAddFileAsSource->setText( tr( "Add as Audio Source" ) );
        connect( btnAddFileAsSource, SIGNAL(clicked()), this, SLOT(btnAddFileAsSource_clicked()));
        //QToolTip::add( btnAddFileAsSource, tr( "Add this file/cd-track to song project as an audio source" ) );
        Layout34_2->addWidget( btnAddFileAsSource );

        btnImportFileNow = new QPushButton( privateLayoutWidget_15, "btnImportFileNow" );
        btnImportFileNow->setText( tr( "Import now!" ) );
        connect( btnImportFileNow, SIGNAL(clicked()), this, SLOT(btnImportNow_clicked()));
        //QToolTip::add( btnImportFileNow, tr( "Add this file/cd-track to song project as an audio source" ) );
        Layout34_2->addWidget( btnImportFileNow );

        QWidget* privateLayoutWidget_16 = new QWidget( grpImportFile, "Layout19_2_2" );
        privateLayoutWidget_16->setGeometry( QRect( 20, 50, 670, 22 ) );
        Layout19_2_2 = new QHBoxLayout( privateLayoutWidget_16, 0, 6, "Layout19_2_2");

        pbarFileImport = new QProgressBar( privateLayoutWidget_16, "pbarFileImport" );
        pbarFileImport->setProgress( 0 );
        Layout19_2_2->addWidget( pbarFileImport );

        checkFileFakeImport = new QCheckBox( privateLayoutWidget_16, "checkFileFakeImport" );
        checkFileFakeImport->setText( tr( "Fake Import" ) );
        //QToolTip::add( checkFileFakeImport, tr( "Just import the audio source, spending the same amout of time, but does not put it into the song as audio source" ) );
        Layout19_2_2->addWidget( checkFileFakeImport );
        mainTabPane->insertTab( tab_4, "<FB> File Broswer" );

        tab_5 = new QWidget( mainTabPane, "tab_5" );

        lblCDBrowser_2 = new QLabel( tab_5, "lblCDBrowser_2" );
        lblCDBrowser_2->setGeometry( QRect( 290, 160, 120, 20 ) );
        lblCDBrowser_2->setText( tr( "Audio CD Browser" ) );

        grpImportCDA = new QGroupBox( tab_5, "grpImportCDA" );
        grpImportCDA->setGeometry( QRect( 10, 260, 700, 80 ) );
        grpImportCDA->setTitle( tr( "Import" ) );

        QWidget* privateLayoutWidget_17 = new QWidget( grpImportCDA, "Layout34" );
        privateLayoutWidget_17->setGeometry( QRect( 20, 20, 670, 24 ) );
        Layout34 = new QHBoxLayout( privateLayoutWidget_17, 0, 6, "Layout34");

        lblDestSongCDA = new QLabel( privateLayoutWidget_17, "lblDestSongCDA" );
        lblDestSongCDA->setMaximumSize( QSize( 57, 32767 ) );
        lblDestSongCDA->setText( tr( "Dest: Song" ) );
        Layout34->addWidget( lblDestSongCDA );

        fieldDestSongCDA = new QLineEdit( privateLayoutWidget_17, "fieldDestSongCDA" );
        fieldDestSongCDA->setMaximumSize( QSize( 25, 32767 ) );
        fieldDestSongCDA->setText( tr( "1" ) );
        Layout34->addWidget( fieldDestSongCDA );

        lblDestTrackCDA = new QLabel( privateLayoutWidget_17, "lblDestTrackCDA" );
        lblDestTrackCDA->setMaximumSize( QSize( 36, 32767 ) );
        lblDestTrackCDA->setText( tr( "Track" ) );
        Layout34->addWidget( lblDestTrackCDA );

        fieldDestTrackCDA = new QLineEdit( privateLayoutWidget_17, "fieldDestTrackCDA" );
        fieldDestTrackCDA->setMaximumSize( QSize( 25, 32767 ) );
        fieldDestTrackCDA->setText( tr( "1" ) );
        Layout34->addWidget( fieldDestTrackCDA );

        lblDestPosCDA = new QLabel( privateLayoutWidget_17, "lblDestPosCDA" );
        lblDestPosCDA->setMaximumSize( QSize( 25, 32767 ) );
        lblDestPosCDA->setText( tr( "Pos" ) );
        Layout34->addWidget( lblDestPosCDA );

        fieldDestPosCDA = new QLineEdit( privateLayoutWidget_17, "fieldDestPosCDA" );
        fieldDestPosCDA->setMinimumSize( QSize( 77, 0 ) );
        fieldDestPosCDA->setMaximumSize( QSize( 55, 32767 ) );
        fieldDestPosCDA->setText( tr( "0:02:30,14" ) );
        Layout34->addWidget( fieldDestPosCDA );

        btnAddSourceCDA = new QPushButton( privateLayoutWidget_17, "btnAddSourceCDA" );
        connect( btnAddSourceCDA, SIGNAL(clicked()), this, SLOT(btnAddSourceCDA_clicked()));
        btnAddSourceCDA->setText( tr( "Add as Audio Source" ) );
        //QToolTip::add( btnAddSourceCDA, tr( "Add this file/cd-track to song project as an audio source" ) );
        Layout34->addWidget( btnAddSourceCDA );

        btnImportNowCDA = new QPushButton( privateLayoutWidget_17, "btnImportNowCDA" );
        connect( btnImportNowCDA, SIGNAL(clicked()), this, SLOT(btnImportNowCDA_clicked()));
        btnImportNowCDA->setText( tr( "Import now!" ) );
        //QToolTip::add( btnImportNowCDA, tr( "Add this file/cd-track to song project as an audio source" ) );
        Layout34->addWidget( btnImportNowCDA );

        QWidget* privateLayoutWidget_18 = new QWidget( grpImportCDA, "Layout19_2" );
        privateLayoutWidget_18->setGeometry( QRect( 20, 50, 670, 22 ) );
        Layout19_2 = new QHBoxLayout( privateLayoutWidget_18, 0, 6, "Layout19_2");

        pbarImportCDA = new QProgressBar( privateLayoutWidget_18, "pbarImportCDA" );
        pbarImportCDA->setProgress( 0 );
        Layout19_2->addWidget( pbarImportCDA );

        checkFakeImportCDA = new QCheckBox( privateLayoutWidget_18, "checkFakeImportCDA" );
        checkFakeImportCDA->setText( tr( "Fake Import" ) );
        //QToolTip::add( checkFakeImportCDA, tr( "Just import the audio source, spending the same amout of time, but does not put it into the song as audio source" ) );
        Layout19_2->addWidget( checkFakeImportCDA );

        grpPreListenCDA = new QGroupBox( tab_5, "grpPreListenCDA" );
        grpPreListenCDA->setGeometry( QRect( 10, 340, 700, 110 ) );
        grpPreListenCDA->setTitle( tr( "Pre-listen" ) );

        QWidget* privateLayoutWidget_19 = new QWidget( grpPreListenCDA, "Layout32_2_2" );
        privateLayoutWidget_19->setGeometry( QRect( 10, 50, 260, 16 ) );
        Layout32_2_2 = new QHBoxLayout( privateLayoutWidget_19, 0, 6, "Layout32_2_2");

        lblCDAVol = new QLabel( privateLayoutWidget_19, "lblCDAVol" );
        lblCDAVol->setText( tr( "Vol" ) );
        Layout32_2_2->addWidget( lblCDAVol );

        sliderCDA = new QSlider( privateLayoutWidget_19, "sliderCDA" );
        sliderCDA->setMaximumSize( QSize( 32767, 14 ) );
        sliderCDA->setOrientation( QSlider::Horizontal );
        Layout32_2_2->addWidget( sliderCDA );

        btnCDAPlay = new QPushButton( grpPreListenCDA, "btnCDAPlay" );
        connect( btnCDAPlay, SIGNAL(clicked()), this, SLOT(btnCDAPlay_clicked()));
        btnCDAPlay->setGeometry( QRect( 10, 20, 260, 22 ) );
        btnCDAPlay->setText( tr( "Play" ) );
        mainTabPane->insertTab( tab_5, tr( "Audio CD Broswer" ) );

        mainTabPane->setCurrentPage ( 0 );

	currentProject = NULL;

        PEXITCONS;
}

ProjectManager::~ProjectManager()
        {
        PENTERDES;
        PEXITDES;
        }

void ProjectManager::show()
        {
        QWidget::show();
        update_projects_list();
        }


void ProjectManager::update_projects_list()
        {
        listAlbumProjects->clear();

        QString projsDir(getenv("HOME"));
        projsDir = projsDir + "/protuxprojects/";

        QDir pDir( projsDir );

        const QFileInfoList* files = pDir.entryInfoList();
        if ( files )
                {
                QFileInfoListIterator it( *files );
                QFileInfo* fi;
                while( (fi=it.current()) != 0 )
                        {
                        ++it;
                        if ( (fi->fileName() != ".") && (fi->fileName() != "..") )
                                {
                                QListViewItem * item = new QListViewItem( listAlbumProjects, 0 );
                                item->setText( 0, fi->fileName() );
                                }
                        }
                }
        }


// delete file/dir pName after prepending $HOME/protuxprojects/ to it
//
// if it is a directory, calls itself recursively  on any file/dir in the directory
// before removing the directory
int ProjectManager::remove_recursively(QString pName)
        {
	  QString name(getenv("HOME"));
	  name = name + "/protuxprojects/" + pName;

	  // check if we are removing the currentProject, and delete it before removing its files
	  if (project_is_current(pName))
	          {
		  if (currentProject->get_current_song()->get_status() != Song::STOPPED)
		          {
			    PERROR("current song is not stopped\n");
			    PEXIT;
			    return -1;
			  }

	    PMESG("removing current project\n");
	    delete currentProject;
	    currentProject = NULL;
	    }

	  QFileInfo fileInfo(name);

	  if (!fileInfo.exists())
	      return -1;
	  if (!fileInfo.isWritable())
	    {
	      PERROR("failed to remove %s: you don't have write access to it\n", name.latin1());
	      return -1;
	    }

	  if(fileInfo.isFile())
	    {
	      QFile file(name);
	      if (!file.remove())
		{
		  PERROR("failed to remove file %s\n", name.latin1());
		  return -1;
		}
	      return 0;
	    }
	  else if(fileInfo.isDir())
	    {
	      QDir dir(name);

	      const QFileInfoList *files = dir.entryInfoList();
	      if (files)
		{
		  QFileInfoListIterator it( *files);
		  QFileInfo *fi;
		  while ((fi = it.current()) != 0)
		    {
		      QString filename(fi->fileName());
		      if ((filename != ".") && (filename != ".."))
			{
			  remove_recursively(pName + "/" + filename);
			}
		      ++it;
		    }
		}
	      if (!dir.rmdir(name))
		{
		  PERROR("failed to remove directory %s\n", name.latin1());
		  return -1;
		}

	      return 0;
	    }
	  
	  return -1;
	}


int ProjectManager::copy_recursively(QString pNameFrom, QString pNameTo)
        {
	if (currentProject && (currentProject->get_current_song()->get_status() != Song::STOPPED))
	        {
		PERROR("current song is not stopped\n");
		PEXIT;
		return -1;
		}

	        QString nameFrom(getenv("HOME"));
		QString nameTo(nameFrom);
		nameFrom = nameFrom + "/protuxprojects/" + pNameFrom;
		nameTo = nameTo + "/protuxprojects/" + pNameTo;

		QFileInfo fileFromInfo(nameFrom);
		QFileInfo fileToInfo(nameTo);

		if (!fileFromInfo.exists())
		{
		        PERROR("File or directory %s doesn't exist\n", pNameFrom.latin1());
			return -1;
		}
		if (fileToInfo.exists())
		{
		        PERROR("File or directory %s already exists", pNameTo.latin1());
			return -1;
		}

		if(fileFromInfo.isFile())
		        {
			  QFile fileFrom(nameFrom);
			  if (!fileFrom.open(IO_ReadOnly))
			          {
				  PERROR("failed to open file %s for reading\n", nameFrom.latin1());
				  return -1;
				  }

			  QFile fileTo(nameTo);
			  if (!fileTo.open(IO_WriteOnly))
			          {
				  fileFrom.close();
				  PERROR("failed to open file for writting%s\n", nameFrom.latin1());
				  return -1;
				  }

			  // the real copy part should perhaps be implemented using QDataStream
			  // but .handle() will still be needed to get the optimal block-size
			  //
			  //! \todo does not keep file mode yet
			  int bufferSize = 4096;
			  int fileDescFrom = fileFrom.handle();
			  int fileDescTo = fileTo.handle();
			  struct stat fileStat;
			  if (fstat(fileDescFrom, &fileStat) == 0)
			          bufferSize = (int)fileStat.st_blksize;
			  
			  void *buffer = malloc(sizeof(char) * bufferSize);
			  // QMemArray<char> buffer(bufferSize);

			  for (;;)
			          {
				  int nRead = read(fileDescFrom, buffer, bufferSize);
				  if (nRead < 0)
				          {
					  fileFrom.close();
					  fileTo.close();
					  PERROR("Error while reading file %s\n", nameFrom.latin1());
					  return -1;
					  }
				  if (nRead == 0)
				          break;
				  if (write(fileDescTo, buffer, nRead) < 0)
				          {
					  fileFrom.close();
					  fileTo.close();
					  PERROR("Error while writing file %s\n", nameTo.latin1());
					  return -1;
					  }
				  }
			  free(buffer);

			  fileFrom.close();
			  fileTo.close();
			  
			  return 0;
			}
		else if(fileFromInfo.isDir())
		        {
			QDir dirFrom(nameFrom);
			QDir dirTo(nameTo);
			if (!dirTo.mkdir(nameTo))
			        {
				PERROR("failed to create directory %s\n", nameTo.latin1());
				return -1;
				}

			const QFileInfoList *files = dirFrom.entryInfoList();
			if (files)
			        {
				QFileInfoListIterator it( *files);
				QFileInfo *fi;
				while ((fi = it.current()) != 0)
				        {
					QString filename(fi->fileName());
					if ((filename != ".") && (filename != ".."))
					        {
						copy_recursively(pNameFrom + "/" + filename, pNameTo + "/" + filename);
						}
					++it;
					}
				}
			return 0;
			}
		return -1;
	}



void ProjectManager::set_current_project(Project* pProject)
        {
        currentProject = pProject;
        if (currentProject)
                {
                btnMaster->setEnabled( true );
                btnSaveProject->setEnabled( true );
                fieldAlbumTitle->setText( currentProject->get_title() );
		QString sNOfSongs;
		sNOfSongs.setNum(currentProject->get_number_of_songs());
		fieldNOfSongs->setText(sNOfSongs);
		fieldEngineer->setText(currentProject->get_engineer());
                // TODO : load all project settings and put them into the widgets...
		// done... at least for the currently available settings ;-) /Martin
                }
        else
                {
                btnMaster->setEnabled( FALSE );
                btnSaveProject->setEnabled( FALSE );
                }
        }


int ProjectManager::create_new_project(QString projectName, int numSong)
        {
	PENTER;

	if (currentProject && (currentProject->get_current_song()->get_status() != Song::STOPPED))
	        {
		PERROR("current song is not stopped\n");
		PEXIT;
		return -1;
		}

	if(projectExists(projectName))
	        {
		PERROR("project %s already exists\n", projectName.latin1());
		PEXIT;
		return -1;
		}

	Project *newProject = new Project(projectName, parentInterface);
	if (!newProject)
	        return -1;

	if (newProject->create(numSong) < 0)  
	        {
        	delete newProject;
	        PERROR("couldn't create new project %s", projectName.latin1());
        	PEXIT;
                return -1;
        	}

	if (currentProject)
	        delete currentProject;

	set_current_project(newProject);
	parentInterface->set_current_project(newProject);
	currentProject->save();
  
	PEXIT;
	return 0;
	}


int ProjectManager::load_project(QString projectName)
        {
	PENTER;

	if (currentProject && (currentProject && (currentProject->get_current_song()->get_status() != Song::STOPPED)))
	        {
		PERROR("current song is not stopped\n");
		PEXIT;
		return -1;
		}

	if(!projectExists(projectName))
	        {
		PERROR("project %s doesn't exist\n", projectName.latin1());
		PEXIT;
		return -1;
		}

	Project *newProject = new Project(projectName, parentInterface);
	if (!newProject)
	        return -1;

	if (newProject->load() < 0)
	        {
                delete newProject;
                PERROR("couldn't load project %s", projectName.latin1());
                PEXIT;
                return -1;
                }
  
	if (currentProject)
	        delete currentProject;
  
	set_current_project(newProject);
	parentInterface->set_current_project(newProject);

	PEXIT;
	return 0;
	}


bool ProjectManager::project_is_current(QString title)
        {
	QString path(getenv("HOME"));
	path = path + "/protuxprojects/" + title;

	if (currentProject && (currentProject->get_root_dir() == path))
	        return true;
	return false;
	}




bool ProjectManager::projectExists(QString title)
{
	QString path(getenv("HOME"));
	QFileInfo fileInfo(path + "/protuxprojects/" + title);
	if (fileInfo.exists())
		return true;
	return false;
}


// ------------------------------- xxx_clicked()
void ProjectManager::listAlbumProject_projectSelected()
        {
	QListViewItem *item = NULL;

	if ((item = listAlbumProjects->currentItem()) == 0)
		return;
	
	fieldSaveProjAs->setText(item->text(0));
	}


void ProjectManager::btnCreateProject_clicked()
        {
	// is current song stopped ?
	if (currentProject && (currentProject->get_current_song()->get_status() != Song::STOPPED))
	        {
		QMessageBox::warning(this,
				       "Protux - Warning",
				       "This operation is not permitted while a song is playing,\nrecording, or some tracks are armed",
				       "Ok");
		return;
		}

	// do we have the name of the project to create ?
	QString title;
	title = fieldSaveProjAs->text();
	if (title.length() == 0)
	        {
		QMessageBox::warning(this,
				     "Protux - Warning",
				     "You must supply a name for the project",
				     "Ok");
		return;
		}

	// ask if the current project should first be saved
	// todo: only ask if project has not been saved
	if (currentProject)
	        switch (QMessageBox::information(this,
						 "Protux - Question",
						 "Should the current project first be saved ?",
						 "Yes", "No", QString::null, 0, -1))
	                {
			case -1:
			        return;
				break;
			case 0:
		                currentProject->save();
				break;
			default:
			        break;
			}

	// first test if project exists already
	if (projectExists(title))
	        {
		  switch (QMessageBox::information(this,
						   "Protux - Question",
						   "The project \"" + title + "\" already exists, do you want to remove it and replace it with a new one ?",
						   "Yes", "No", QString::null, 1, -1))
		          {
			  case 0:
			          remove_recursively(title);
				  break;
			  default:
			          return;
				  break;
			  }
		}

	  if( create_new_project(title, 2) < 0)
	          QMessageBox::warning(this,
				       "Protux - Error", "Couldn't create project \"" + title +"\"",
				       "Ok");
	  update_projects_list();
        }


void ProjectManager::btnImportNow_clicked()
        {
        if (currentProject)
                currentProject->import_audio(fileBrowser->filename->text());
        }


void ProjectManager::btnSaveProject_clicked()
        {
	// is current song stopped ?
	if (currentProject && (currentProject->get_current_song()->get_status() != Song::STOPPED))
	        {
		QMessageBox::warning(this,
				       "Protux - Warning",
				       "This operation is not permitted while a song is playing,\nrecording, or some tracks are armed",
				       "Ok");
		return;
		}

        if (currentProject)
                {
		currentProject->set_title(fieldAlbumTitle->text());
		currentProject->set_engineer(fieldEngineer->text());
                currentProject->save();
                QMessageBox::warning( 0, "Project Saved", "Project \"" + currentProject->title + "\" saved.");
                }
        }


void ProjectManager::btnLoadProject_clicked()
        {
	// is current song stopped ?
	if (currentProject && (currentProject->get_current_song()->get_status() != Song::STOPPED))
	        {
		QMessageBox::warning(this,
				       "Protux - Warning",
				       "This operation is not permitted while a song is playing,\nrecording, or some tracks are armed",
				       "Ok");
		return;
		}

	// do we have the name of the project to load ?
	QString title;
	title = fieldSaveProjAs->text();
	if (title.length() == 0)
	        {
		QMessageBox::warning(this,
				     "Protux - Warning",
				     "You must supply a name for the project",
				     "Ok");
		return;
		}

	// ask if the current project should first be saved
	//! \todo only ask if project has not been saved
	if (currentProject)
	        switch (QMessageBox::information(this,
						 "Protux - Question",
						 "Should the current project first be saved ?",
						 "Yes", "No", QString::null, 0, -1))
	                {
			case -1:
		                return;
				break;
			case 0:
			        currentProject->save();
				break;
			default:
		                break;
			}

	// first test if project exists
	if (!projectExists(title))
	        {
		QMessageBox::warning(this,
				     "Protux - Warning",
				     "The project \"" + title + "\" doesn't exist",
				     "Ok");
		update_projects_list();
		return;
		}

	  load_project(title);
	}


void ProjectManager::btnCopyToProject_clicked()
        {
	// is current song stopped ?
	if (currentProject && (currentProject->get_current_song()->get_status() != Song::STOPPED))
	        {
		QMessageBox::warning(this,
				       "Protux - Warning",
				       "This operation is not permitted while a song is playing,\nrecording, or some tracks are armed",
				       "Ok");
		return;
		}

	// do we have the name of the project to create ?
	if (!currentProject)
	        return; // display a warning

	QString projectTo;
	projectTo = fieldSaveProjAs->text();
	if (projectTo.length() == 0)
	        {
		QMessageBox::warning(this,
				     "Protux - Warning",
				     "You must supply a name for the project",
				     "Ok");
		return;
		}

	// the current project should first be saved
	//! \todo only ask if project has not been saved
	if (currentProject)
	        switch (QMessageBox::information(this,
						 "Protux - Question",
						 "The current project has first to be saved before you can copy it !\nFuture versions will hopefully get rid of this constraint.",
						 "Ok", "Cancel", QString::null, 0, -1))
	                {
			case 0:
			        currentProject->save();
				break;
			default:
			        return;
		                break;
			}

	// first test if project exists already
	if (projectExists(projectTo))
	        {
		  switch (QMessageBox::information(this,
						   "Protux - Question",
						   "The project \"" + projectTo + "\" already exists, do you want to remove it and replace it with the current one ?",
						   "Yes", "No", QString::null, 1, -1))
		          {
			  case 0:
			          remove_recursively(projectTo);
				  break;
			  default:
			          return;
				  break;
			  }
		}

	QString projectFrom(currentProject->get_root_dir());
	projectFrom = projectFrom.section("/", -1);
	copy_recursively(projectFrom, projectTo);
	update_projects_list();
	load_project(projectTo);
        }


void ProjectManager::btnDeleteProject_clicked()
        {
	// do we have the name of the project to delete ?
	QString title;
	title = fieldSaveProjAs->text();
	if (title.length() == 0)
	        {
		QMessageBox::warning(this,
				     "Protux - Warning",
				     "You must supply a name for the project",
				     "Ok");
		return;
		}

	// if deleting current project, is current song stopped ?
	if ((project_is_current(title)) && currentProject && (currentProject->get_current_song()->get_status() != Song::STOPPED))
	        {
		QMessageBox::warning(this,
				       "Protux - Warning",
				       "This operation is not permitted while a song is playing,\nrecording, or some tracks are armed",
				       "Ok");
		return;
		}

	// first test if project exists
	if (!projectExists(title))
	        {
		QMessageBox::warning(this,
				     "Protux - Error",
				     "The project \"" + title + "\" doesn't exist",
				     "Ok");
		update_projects_list();
		return;
		}
	  
	switch (QMessageBox::information(this,
					 "Protux - Question",
					 "Are you sure that you want to remove the project \"" + title + "\" ? It's not possible to undo it !",
					 "Yes", "No", QString::null, 1, -1))
	        {
		case 0:
		        remove_recursively(title);
			update_projects_list();
			break;
		default:
		        return;
			break;
		}
	return;
        }



void ProjectManager::btnSaveSong_clicked()
        {
        DevelGuardian::warn_not_implemented("SAVE SONG","Protux saves all songs under the current project automatically , for now");
        }
void ProjectManager::btnSaveSongAs_clicked()
        {
        DevelGuardian::warn_not_implemented("SAVE SONG AS","Sorry dude, no tips here...");
        }


void ProjectManager::btnSaveSongCopyAs_clicked()
        {
        DevelGuardian::warn_not_implemented("COPY SONG COPY AS","No tip for this lack.. sorry :-}");
        }
void ProjectManager::btnDeleteSource_clicked()
        {
        DevelGuardian::warn_not_implemented("DELETE AUDIO SOURCE","Remove it manually under /home/you/protuxprojects/untitled/song_x/audiosources/");
        }
void ProjectManager::btnRemoveAllClips_clicked()
        {
        DevelGuardian::warn_not_implemented("REMOVE ALL CLIPS","Don't hate us, but you will have to delete all them manually");
        }
void ProjectManager::btnExportSource_clicked()
        {
        DevelGuardian::warn_not_implemented("EXPORT SOURCE","Try to convert the audio source manually with genpraf, ogg123, mpg123, notlame, or some other console tool");
        }
void ProjectManager::btnSourcePlay_clicked()
        {
        DevelGuardian::warn_not_implemented("PLAY SOURCE","You can normally play it after loading it, but there no way to play it here in the Project Manager, for now...");
        }
void ProjectManager::btnFilePlay_clicked()
        {
        DevelGuardian::warn_not_implemented("FILE PLAY (INSIDE PROJECT MANAGER)","Use standard play tools to play it outside protux");
        }
void ProjectManager::btnAddFileAsSource_clicked()
        {
        DevelGuardian::warn_not_implemented("ADD AS AUDIO SOURCE","Import it normally then it will become an audio source");
        }
void ProjectManager::btnAddSourceCDA_clicked()
        {
        DevelGuardian::warn_not_implemented("Import CDA track as audio source","Use \"cdda2wav -D/dev/cdrom -tX\" in\na console to import it (Note: X is the number of the track)");
        }
void ProjectManager::btnImportNowCDA_clicked()
        {
        DevelGuardian::warn_not_implemented("Import CDA track as audio source","Use \"cdda2wav -D/dev/cdrom -tX\" in\na console to import it (Note: X is the number of the track)");
        }
void ProjectManager::btnCDAPlay_clicked()
        {
        DevelGuardian::warn_not_implemented("CD PLAYER","Use the KDE or the Gnome CD player");
        }

void ProjectManager::btnRender_clicked()
        {
        DevelGuardian::warn_not_implemented("FULL PROJECT RENDER","You can render each song a time by <<ENTER>> in them");
        }

void ProjectManager::btnMaster_clicked()
        {
        DevelGuardian::warn_not_implemented("MASTER PROJECT","This is feature for a very distant future release.");
        }

void ProjectManager::btnBurnCD_clicked()
        {
        DevelGuardian::warn_not_implemented("BURN CD ","We suggest xcdroast to burning CDs");
        }

/*
const char* ProjectManager::get_curr_project_name() // DEPRACATED ???
        {
                QString pn = fieldAlbumTitle->text();
                return pn.ascii();
        }


const char* ProjectManager::get_curr_project_name() // DEPRACATED ???
        {
                QString pn = fieldAlbumTitle->text();
                return pn.ascii();
        }

int ProjectManager::get_curr_project_num_songs() // DEPRACATED ???
        {
                QString ns = fieldNOfSongs->text();
                return atoi(ns.ascii());
        }
*/
// eof
