/**************************************************************************************

        PROTUX - THE FREE PROFESSIONAL AUDIO TOOLS FOR LINUX
        AUTHOR : See AUTHORS file for details

        This software is distributed under the terms of the GNU General Public License
        as specified in the COPYING file.

***************************************************************************************/

#ifndef TRACKPANELVU_HH
#define TRACKPANELVU_HH

#include <mustux.h>


class TrackPanel;

class TrackPanelVU : public MustuxEngine
        {
        Q_OBJECT
        public :
                TrackPanelVU(TrackPanel* pAssocTrackPanel, int pChannels =2, int pRate=44100 , int pBitDepth=16);
                ~TrackPanelVU();

                int activate();
                int deactivate();
                
                bool is_active();

                void clear();

                void update_levels(float * levels);

        public slots:

                void update();

        private :
                TrackPanel* assocTrackPanel;
                MustuxDrawable* drawArea;
                int channels;
                int rate;
                int bitDepth;

                int lCurrLevel;
                int rCurrLevel;
                bool isActive;
                QTimer* updateTimer;

        };


#include "TrackPanel.hh"

#endif



