#include "DelayController.hh"

DelayController::DelayController(Song* pParentSong, MustuxDrawable* pDrawArea, AudioFilter* pFilter )
        : FilterController(pParentSong, pDrawArea, pFilter)
        {
        PENTERCONS;
        PEXITCONS;
        }

DelayController::~DelayController()
        {
        PENTERDES;
        PEXITDES;
        }


void DelayController::node_setup()
        {
        curve[currentCurveIndex]->get_current_curve_node()->setup();
        }


void DelayController::setup()
        {
        FilterController::setup();
        }


QString DelayController::get_type()
        {
        return "Delay";
        }

int DelayController::get_baseX()
        {
        return baseX;
        }


int DelayController::get_baseY()
        {
        return baseY;
        }

int DelayController::get_width()
        {
        return drawArea->width();
        }

int DelayController::get_height()
        {
        return height;
        }

void DelayController::set_baseX(int initialValue)
        {
        baseX=initialValue;
        }

void DelayController::set_baseY(int initialValue)
        {
        baseY=initialValue;
        }

void DelayController::set_width(int initialValue)
        {
        width=initialValue;
        }

void DelayController::set_height(int initialValue)
        {
        height=initialValue;
        }

void DelayController::draw()
        {
        PENTER;
        FilterController::draw();
        PEXIT;
        }


int DelayController::process(char* data, int size)
        {
        if (assocFilter->load_data(data,size)<0) return -1;
        if (assocFilter->prepare()<0) return -1;
        if (assocFilter->process()<0) return -1;
        return 1;
        }

//eof

//eof
