#include "OctaverController.hh"
#include <mustux.h>

OctaverController::OctaverController(Song* pParentSong, MustuxDrawable* pDrawArea, AudioFilter* pFilter )
        : FilterController(pParentSong, pDrawArea, pFilter)
        {
        PENTERCONS;
        PEXITCONS;
        }

OctaverController::~OctaverController()
        {
        }

void OctaverController::node_setup()
        {
        curve[currentCurveIndex]->get_current_curve_node()->setup();
        }


void OctaverController::setup()
        {
        FilterController::setup();
        }


QString OctaverController::get_type()
        {
        return "Octaver";
        }

int OctaverController::get_baseX()
        {
        return baseX;
        }


int OctaverController::get_baseY()
        {
        return baseY;
        }

int OctaverController::get_width()
        {
        return drawArea->width();
        }

int OctaverController::get_height()
        {
        return height;
        }

void OctaverController::set_baseX(int initialValue)
        {
        baseX=initialValue;
        }

void OctaverController::set_baseY(int initialValue)
        {
        baseY=initialValue;
        }

void OctaverController::set_width(int initialValue)
        {
        width=initialValue;
        }

void OctaverController::set_height(int initialValue)
        {
        height=initialValue;
        }

void OctaverController::draw()
        {
        PENTER;
        FilterController::draw();
        PEXIT;
        }


int OctaverController::process(char* data, int size)
        {
        //int numOctaves = -1.0*(curveThreshold->get_value_at(parentSong->get_playing_block()) - 100)/20-5; // -5..5 octaves
        //((Octaver*) assocFilter)->set_amount(numOctaves);
        if (assocFilter->load_data(data,size)<0) return -1;
        if (assocFilter->prepare()<0) return -1;
        if (assocFilter->process()<0) return -1;
        return 1;
        }

//eof
