#include "ReverbController.hh"
#include <mustux.h>

ReverbController::ReverbController(Song* pParentSong, MustuxDrawable* pDrawArea, AudioFilter* pFilter ) : FilterController(pParentSong, pDrawArea, pFilter)
        {
        PENTERCONS;
        PEXITCONS;
        }

ReverbController::~ReverbController()
        {
        }

QString ReverbController::get_type()
        {
        return "Reverb";
        }

void  ReverbController::node_setup()
        {
	curve[currentCurveIndex]->get_current_curve_node()->setup();
        }


void  ReverbController::setup()
	{
	FilterController::setup();
	}

int ReverbController::get_baseX()
        {
        return baseX;
        }

int ReverbController::get_baseY()
        {
        return baseY;
        }

int ReverbController::get_width()
        {
        return drawArea->width();
        }

int ReverbController::get_height()
        {
        return height;
        }

void ReverbController::set_baseX(int initialValue)
        {
        baseX=initialValue;
        }

void ReverbController::set_baseY(int initialValue)
        {
        baseY=initialValue;
        }

void ReverbController::set_width(int initialValue)
        {
        width=initialValue;
        }

void ReverbController::set_height(int initialValue)
        {
        height=initialValue;
        }

void ReverbController::draw()
        {
        PENTER;
        FilterController::draw();
        PEXIT;
        }

//eof
